#include	"mview.h"
#include	"window.h"

extern WindowID	Bwp;
static WindowID	Swp;
static int	OnSwitch, TargetMen;

static int	WinScExec( WindowID, EventInfo* );
static int	WinExec( WindowID, EventInfo* );
int	WinManager( int );


int
WinScExec( wp, info )
WindowID wp;
EventInfo *info;
{
	DrawBuf	dbuf[MENBER_MAX+1], *dp= dbuf;
	int	i;
	
	switch( info->option ){
	case EventOpen:
		TargetMen= 0;	/* 0ԂftHgőI */
		WinOnNum= 1;
		WinOn[0]= 1;	/* }[N */
		for( i= 1; i < WinMax; i++ )	WinOn[i] = 0;
		Swp= wp;
		return TRUE;
	case EventRedraw:
		DrawSetClear( dp++, 1 );
		for( i= 0; i < WinMax; i++ ){
			DrawSetSymbol( dp++, 0, i * 12, WinMenber[ i ].name,
							WinOn[i]? (AttrDefault ^ 8):AttrDefault, 12 );
		}
		WindowDraw( wp, dbuf, dp - dbuf );
		return TRUE;

	case EventClose:
		WindowClose( wp );
		return TRUE;

	case EventMouseSwitch:
		if( info->LeftON && (i= info->y / 12) < WinMax ){
			if( OnSwitch ){			/* I */
				if( WinOn[ i ] ){
					WinOn[ i ]= 0;
					WinOnNum--;
				}else {
					WinOn[ i ]= 1;
					WinOnNum++;
				}
			}else {
					WinOn[ TargetMen ]= 0;
					WinOn[ i ] = 1;
					TargetMen= i;
			}
			WindowRedraw( wp );
		}
		return TRUE;
	}
	return FALSE;
}

int
WinExec( wp, info )
WindowID	wp;
EventInfo	*info;
{
	DrawBuf	dbuf[5], *dp= dbuf;

	switch( info->option ){
	case EventOpen:
		WinOnNum = 0;
		WindowSetEventAttr( wp, EventAttrDefault );
		WindowScrollOpen( 0, 0, 150, 180, wp, 150,(WinMax*12<=176)?176:WinMax*12,
					DirectionY, 12, 12, WinScExec );
		WindowRedraw( wp );
		return	TRUE;
	case EventClose:
		WindowClose( Swp );
		WindowClose( wp );
		return TRUE;
	case EventRedraw:
		DrawSetClear( dp++, 1 );
		DrawSetSymbol( dp++, 18, 184, "  Ok  ", AttrDefault, 12 );
		DrawSetSymbol( dp++, 98, 184, "Cancel", AttrDefault, 12 );
		DrawSetLine( dp++, 16, 182,  55, 197, ShadowUp, OptionShadow );
		DrawSetLine( dp++, 96, 182, 135, 197, ShadowUp, OptionShadow );
		WindowDraw( wp, dbuf, dp - dbuf );
		WindowRedraw( Swp );
		return	TRUE;
	case EventMouseSwitch:
		if( info->y <= 180 ){
			return WindowSendEvent( Swp, info );
		}
		return TRUE;
	}
	return	FALSE;
}

int
WinManager(	mode )
int	mode;
{
	WindowID	cwp, nwp;
	EventInfo	info;
	int	x, y;
	
	OnSwitch= mode;
	WindowGetScreenPosition( Bwp, &x, &y );
	cwp= WindowSimpleOpen( x + 300, y + 20, 150, 200, NULL, WinExec );

	for(;;){
		if( !WindowGetEventInfo( &info ) )	continue;
		nwp= WindowGetChild( WindowRootID, &info );
		if( nwp == cwp ){
			if( info.option == EventClose ){
				TargetMen= -1;
				break;
			}
			if( info.LeftON ){
				if( info.y >182 && info.y < 197 ){
					if( info.x > 16 && info.x < 55 ){
						break;	/* OK */
					}else if( info.x > 96 && info.x < 135 ){
						TargetMen= -1;
						break;	/* Cancel */
					}
				}else {
					WindowSendEvent( cwp, &info );
				}
			}else if( info.option == EventKey ){
				if( info.KeyCode == '\r' ){
					break;	/* RET */
				}else if( info.KeyCode == '\x1b' ){
					TargetMen= -1;
					break;	/* ESC */
				}
			}
		}
		if( nwp && nwp != Bwp ){
			WindowSendEvent( nwp, &info );
		}
	}
	WindowClose( cwp );
	return TargetMen;
}
